<?php
namespace Bushelpowered\Api\Grain\Contracts\V1\Event;
        
class ContractEvent implements Api\Common\Event\Event, Api\Common\Event\StandardEvent
{
    public \Bushelpowered\Api\Grain\Contracts\V1\Model\ContractStandard $data;
    public string $idempotencyKey;
    public int $eventCreationTime;
    public ?string $tenantId = null;

    /**
     * @param  null  $data
     * @param  null  $idempotencyKey
     * @param  null  $eventCreationTime
     * @param  null  $tenantId
     */
    public function __construct(\Bushelpowered\Api\Grain\Contracts\V1\Model\ContractStandard $data, string $idempotencyKey, int $eventCreationTime, ?string $tenantId)
    {
        $this->data = $data;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
    }
    
    public function getData(): \Bushelpowered\Api\Grain\Contracts\V1\Model\ContractStandard
    {
        return $this->data;
    }
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    public function getEventCreationTime(): int
    {
        return $this->eventCreationTime;
    }
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
}