<?php
namespace Bushelpowered\Api\Grain\Contracts\V1\Model;
        
class ContractStandard implements Api\Common\Event\StandardRecord, Api\Common\HasSourceTimestamps, Api\Common\HasTimestamps
{
    public string $id;
    public string $entityRevisionId;
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public string $sourceAccountId;
    public string $accountId;
    public ?string $sourceLocationId = null;
    public ?string $locationId = null;
    public ?string $sourceCommodityId = null;
    public ?string $commodityId = null;
    public ?string $sourceCropYear = null;
    public ?string $sourceDisplayId = null;
    public ?bool $sourceIsClosed = null;
    public ?float $sourceQuantityCanceled = null;
    public ?float $sourceQuantityContracted = null;
    public ?float $sourceQuantityDelivered = null;
    public ?string $sourceQuantityUom = null;
    public ?string $quantityUom = null;
    public ?string $sourceType = null;
    public ?string $sourceSubtype = null;
    public ?string $sourceSignatureStatus = null;
    public ?string $sourceComments = null;
    /** @var \Bushelpowered\Api\Grain\Contracts\V1\Model\PricingLineStandard[] $pricingLines */
    public array $pricingLines;
    public int $updatedAt;
    public int $createdAt;
    public ?int $deletedAt = null;
    public int $sourceCreatedAt;
    public int $sourceUpdatedAt;
    public ?int $sourceDeletedAt = null;

    /**
     * @param  null  $id
     * @param  null  $entityRevisionId
     * @param  null  $tenantId
     * @param  null  $datasourceId
     * @param  null  $integrationId
     * @param  null  $sourceId
     * @param  null  $sourceAccountId
     * @param  null  $accountId
     * @param  null  $sourceLocationId
     * @param  null  $locationId
     * @param  null  $sourceCommodityId
     * @param  null  $commodityId
     * @param  null  $sourceCropYear
     * @param  null  $sourceDisplayId
     * @param  null  $sourceIsClosed
     * @param  null  $sourceQuantityCanceled
     * @param  null  $sourceQuantityContracted
     * @param  null  $sourceQuantityDelivered
     * @param  null  $sourceQuantityUom
     * @param  null  $quantityUom
     * @param  null  $sourceType
     * @param  null  $sourceSubtype
     * @param  null  $sourceSignatureStatus
     * @param  null  $sourceComments
     * @param  \Bushelpowered\Api\Grain\Contracts\V1\Model\PricingLineStandard[]  $pricingLines
     * @param  null  $updatedAt
     * @param  null  $createdAt
     * @param  null  $deletedAt
     * @param  null  $sourceCreatedAt
     * @param  null  $sourceUpdatedAt
     * @param  null  $sourceDeletedAt
     */
    public function __construct(string $id, string $entityRevisionId, string $tenantId, string $datasourceId, string $integrationId, string $sourceId, string $sourceAccountId, string $accountId, ?string $sourceLocationId, ?string $locationId, ?string $sourceCommodityId, ?string $commodityId, ?string $sourceCropYear, ?string $sourceDisplayId, ?bool $sourceIsClosed, ?float $sourceQuantityCanceled, ?float $sourceQuantityContracted, ?float $sourceQuantityDelivered, ?string $sourceQuantityUom, ?string $quantityUom, ?string $sourceType, ?string $sourceSubtype, ?string $sourceSignatureStatus, ?string $sourceComments, array $pricingLines, int $updatedAt, int $createdAt, ?int $deletedAt, int $sourceCreatedAt, int $sourceUpdatedAt, ?int $sourceDeletedAt)
    {
        $this->id = $id;
        $this->entityRevisionId = $entityRevisionId;
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceAccountId = $sourceAccountId;
        $this->accountId = $accountId;
        $this->sourceLocationId = $sourceLocationId;
        $this->locationId = $locationId;
        $this->sourceCommodityId = $sourceCommodityId;
        $this->commodityId = $commodityId;
        $this->sourceCropYear = $sourceCropYear;
        $this->sourceDisplayId = $sourceDisplayId;
        $this->sourceIsClosed = $sourceIsClosed;
        $this->sourceQuantityCanceled = $sourceQuantityCanceled;
        $this->sourceQuantityContracted = $sourceQuantityContracted;
        $this->sourceQuantityDelivered = $sourceQuantityDelivered;
        $this->sourceQuantityUom = $sourceQuantityUom;
        $this->quantityUom = $quantityUom;
        $this->sourceType = $sourceType;
        $this->sourceSubtype = $sourceSubtype;
        $this->sourceSignatureStatus = $sourceSignatureStatus;
        $this->sourceComments = $sourceComments;
        $this->pricingLines = $pricingLines;
        $this->updatedAt = $updatedAt;
        $this->createdAt = $createdAt;
        $this->deletedAt = $deletedAt;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
    }
    
    public function getId(): string
    {
        return $this->id;
    }
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getAccountId(): string
    {
        return $this->accountId;
    }
    public function getLocationId(): ?string
    {
        return $this->locationId;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
    public function getSourceCreatedAt(): int
    {
        return $this->sourceCreatedAt;
    }
    public function getSourceUpdatedAt(): int
    {
        return $this->sourceUpdatedAt;
    }
    public function getSourceDeletedAt(): ?int
    {
        return $this->sourceDeletedAt;
    }
}