<?php
namespace Bushelpowered\Api\Grain\Contracts\V1\Model;
        
class PricingHistoryStandard implements Api\Common\Event\StandardRecord, Api\Common\HasSourceTimestamps, Api\Common\HasTimestamps
{
    public string $id;
    public string $entityRevisionId;
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourcePricingLineId = null;
    public ?string $pricingLineId = null;
    public ?string $sourceType = null;
    public ?float $sourcePrice = null;
    public ?string $sourcePricingMode = null;
    public ?string $accountId = null;
    public ?string $locationId = null;
    public int $updatedAt;
    public int $createdAt;
    public ?int $deletedAt = null;
    public int $sourceCreatedAt;
    public int $sourceUpdatedAt;
    public ?int $sourceDeletedAt = null;

    /**
     * @param  null  $id
     * @param  null  $entityRevisionId
     * @param  null  $tenantId
     * @param  null  $datasourceId
     * @param  null  $integrationId
     * @param  null  $sourceId
     * @param  null  $sourcePricingLineId
     * @param  null  $pricingLineId
     * @param  null  $sourceType
     * @param  null  $sourcePrice
     * @param  null  $sourcePricingMode
     * @param  null  $accountId
     * @param  null  $locationId
     * @param  null  $updatedAt
     * @param  null  $createdAt
     * @param  null  $deletedAt
     * @param  null  $sourceCreatedAt
     * @param  null  $sourceUpdatedAt
     * @param  null  $sourceDeletedAt
     */
    public function __construct(string $id, string $entityRevisionId, string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourcePricingLineId, ?string $pricingLineId, ?string $sourceType, ?float $sourcePrice, ?string $sourcePricingMode, ?string $accountId, ?string $locationId, int $updatedAt, int $createdAt, ?int $deletedAt, int $sourceCreatedAt, int $sourceUpdatedAt, ?int $sourceDeletedAt)
    {
        $this->id = $id;
        $this->entityRevisionId = $entityRevisionId;
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourcePricingLineId = $sourcePricingLineId;
        $this->pricingLineId = $pricingLineId;
        $this->sourceType = $sourceType;
        $this->sourcePrice = $sourcePrice;
        $this->sourcePricingMode = $sourcePricingMode;
        $this->accountId = $accountId;
        $this->locationId = $locationId;
        $this->updatedAt = $updatedAt;
        $this->createdAt = $createdAt;
        $this->deletedAt = $deletedAt;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
    }
    
    public function getId(): string
    {
        return $this->id;
    }
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getAccountId(): ?string
    {
        return $this->accountId;
    }
    public function getLocationId(): ?string
    {
        return $this->locationId;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
    public function getSourceCreatedAt(): int
    {
        return $this->sourceCreatedAt;
    }
    public function getSourceUpdatedAt(): int
    {
        return $this->sourceUpdatedAt;
    }
    public function getSourceDeletedAt(): ?int
    {
        return $this->sourceDeletedAt;
    }
}