<?php
namespace Bushelpowered\Api\Platform\Subscription\V1;

use \Bushelpowered\Api\Platform\Subscription\V1\Request\ResetSubscriptionsRequest;
use \Bushelpowered\Api\Common\Response\EmptyResponse;
use \Bushelpowered\Api\Common\NotFound;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bidl\Php\Core\Builtins\UnknownError;

class ResetSubscriptions 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(ResetSubscriptionsRequest $request, $headers): EmptyResponse | NotFound | NotAuthenticated | NotAuthorized | ConstraintViolation | UnknownError
    {
         return $this->client->call('api/platform/subscription/v1/ResetSubscriptions', $request, new ResetSubscriptionsResponseWrapper(), $headers)->response;
    }
}

class ResetSubscriptionsResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var EmptyResponse | NotFound | NotAuthenticated | NotAuthorized | ConstraintViolation | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.platform.subscription.v1#ResetSubscriptionsSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\Response\EmptyResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotFound':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthorized':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#ConstraintViolation':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}